package org.websparrow.controller;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.websparrow.entity.Customer;
import org.websparrow.repository.CustomerRepository;

@RestController
@RequestMapping("/customer")
public class CustomerController {

	@Autowired
	private CustomerRepository customerRepository;

	@GetMapping("/findbyfirstname")
	public Iterable<Customer> getCustomerByFirstName() {

		return customerRepository.findByFirstName("Sandeep");

	}

	@GetMapping("/findbylastname")
	public Iterable<Customer> getCustomerByLastName() {

		return customerRepository.findByLastName("Sharma");

	}

	@GetMapping("/findbyemail")
	public Optional<Customer> getCustomerByEmail() {

		return customerRepository.findByEmail("jyoti@abc.com");

	}

	@GetMapping("/findbyfirstandlastname")
	public List<Customer> getCustomerByFirstAndLastName() {

		return customerRepository.findByFirstNameAndLastName("Abhinav", "Rathi");

	}

	@GetMapping("/findbyfirstorlastname")
	public List<Customer> getCustomerByFirstOrLastName() {

		return customerRepository.findByFirstNameOrLastName("Sandeep", "Giri");

	}

	@GetMapping("/disctinctcustomerbyfirstname")
	public List<Customer> getDitictCustomerByFirstName() {

		return customerRepository.findCustomerDistinctByFirstNameAndLastName("Sandeep", "Sharma");

	}

	@GetMapping("/findby-firstname-ignorecase")
	public Iterable<Customer> getCustomerByFirstNameIgnoreCase() {

		return customerRepository.findByFirstNameIgnoreCase("Abhinav");

	}

	@GetMapping("/findby-customer-all-ignore")
	public Iterable<Customer> getCustomerByAllIgnoreCase() {

		return customerRepository.findByFirstNameOrCountryAllIgnoreCase("sanGeEtA", "ruSiA");

	}

	@GetMapping("/findby-fristname-orderby-lastname")
	public Iterable<Customer> getCustomerOrderBy() {

		return customerRepository.findByFirstNameOrderByLastNameAsc("Sandeep");

	}

}
