package org.websparrow.repository;

import java.util.List;
import java.util.Optional;

import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;
import org.websparrow.entity.Customer;

@Repository
public interface CustomerRepository extends CrudRepository<Customer, Integer> {

	List<Customer> findByFirstName(String firstName);

	List<Customer> findByLastName(String lastName);

	Optional<Customer> findByEmail(String email);

	List<Customer> findByFirstNameAndLastName(String firstName, String lastName);

	List<Customer> findByFirstNameOrLastName(String firstName, String lastName);

	List<Customer> findCustomerDistinctByFirstNameAndLastName(String firstName, String lastName);

	List<Customer> findByFirstNameIgnoreCase(String firstName);

	List<Customer> findByFirstNameOrCountryAllIgnoreCase(String firstName, String country);

	List<Customer> findByFirstNameOrderByLastNameAsc(String firstName);

	List<Customer> findByFirstNameOrderByCountryDesc(String firstName);

}
